(function () {
    "use strict";

    angular.module('core').controller('condicaoPagamentoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'condicaoPagamentoService', 'lookupService', '$q','$alert'];

    function controller($scope, $timeout, $state, $stateParams, condicaoPagamentoService, lookupService, $q, $alert) {
        $scope.initializeLayout('Condição de Pagamento');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Parcelamento: 1,
            }
        };

        $scope.auxiliar = {
            bandeiracartao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllBandeiraCartao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };


        $scope.addParcelamento = function () {

            condicaoPagamentoService.prepareNewParcela($scope.state.item).then(function (response) {
                if (response.Status < 0) {

                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.item = response.Data;
                }
            },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');

                });
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.prepare = function () {
            $scope.state.salvando = true;
            condicaoPagamentoService
                .prepare($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $alert({ text: "Não foi possível conectar com o(s) servidor(es).", title: $scope.Title });
                    });
        };
        $scope.save = function () {
            debugger
            $scope.state.salvando = true;
            condicaoPagamentoService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.popups.add.toggle();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };
        $scope.delete = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            var args = { id: $scope.state.item.ID };
            condicaoPagamentoService
                .delete(args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            condicaoPagamentoService
                .get($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.item = response.Data;
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = !$scope.state.item;
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();